variables:
  DOCS_DIR: docs

build:html:
  stage: build
  image: registry.gitlab.com/gaia-x/toolset/gaia-x-document-template/builder:main-latest
  before_script:
    - mkdir --parents public/html || true
  script:
    - cp --recursive /mkdocs/template_* ${DOCS_DIR}/
    - j2 mkdocs.yml.j2 -o mkdocs.yml
    - cat mkdocs.yml
    - mkdocs build
    - cp --recursive build/* public/html/
  artifacts:
    paths:
      - public

build:pdf:prepare:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  needs: ["build:html"]
  script:
    - if [ "$GITLAB_CI" == false ]; then CI_PROJECT_DIR=/mnt; fi
    - apk add --no-cache findutils
    - docker pull minlag/mermaid-cli:latest
    - |+
      for f in $(find ${CI_PROJECT_DIR}/${DOCS_DIR} -name '*.md' -printf '%P\n'); do
        docker run --user ${UID:-root} --volume ${CI_PROJECT_DIR}/${DOCS_DIR}:/docs minlag/mermaid-cli:latest -i /docs/"$f" --outputFormat png -o /docs/"$f" -b transparent
      done
    - cp --recursive ${CI_PROJECT_DIR}/${DOCS_DIR} public/ # save modified documents under public/
  artifacts:
    paths:
      - public

build:pdf:
  stage: build
  image: registry.gitlab.com/gaia-x/toolset/gaia-x-document-template/builder:main-latest
  needs: ["build:pdf:prepare"]
  variables:
    generate_pdf: 1
  script:
    - cp --recursive /mkdocs/template_* ${DOCS_DIR}/
    - cp --recursive public/${DOCS_DIR}/* ${DOCS_DIR}/ # restore modified documents from public/
    - pip install beautifulsoup4==4.9.* # https://github.com/orzih/mkdocs-with-pdf/issues/79
    - j2 mkdocs.yml.j2 -o mkdocs.yml
    - cat mkdocs.yml
    - mkdocs build
    - cp build/pdf/document.pdf public/
  artifacts:
    paths:
      - public

upload_html_doc:
  image: alpine:3
  stage: .post
  before_script:
    - apk update
    - apk add rsync
    - apk add sshpass
  script:
    - PATH=${CI_PROJECT_PATH//gaia-x\//}
    - sshpass -p ${DOCS_GAIAX_PASS} rsync -ae "ssh public/  ${DOCS_GAIAX_USER}@${DOCS_GAIAX_HOST}:~/${PATH}/${CI_COMMIT_TAG}"
  only:
    - /^2[1-9].[0-1][0-9]$/


pages:
  stage: .post
  script:
    - cp --recursive public/html/* public/
  artifacts:
    paths:
      - public # do not change it https://gitlab.com/gitlab-org/gitlab/-/issues/1719#note_30008931
  only:
    - master
    - main
